package fr.iut.pm.movieapplication.data.mapper

import fr.iut.pm.movieapplication.data.entities.GenreEntity
import fr.iut.pm.movieapplication.model.Genre

object GenreLocalMapper {

    fun mapToGenreEntity(genre : Genre) : GenreEntity {
        return GenreEntity(
            genreId = genre.id,
            name = genre.name
        )
    }

    fun mapToGenreEntities(genres : List<Genre>) : List<GenreEntity> {
        return genres.map { mapToGenreEntity(it) }
    }

    fun mapToGenre(genreEntity : GenreEntity) : Genre {
        return Genre(
            id = genreEntity.genreId,
            name = genreEntity.name
        )
    }
}